<template>
  <div>
    <div class="row">
      <div class="col-xs-12 col-md-6">
        <el-input
          v-model="search"
          placeholder="Rechercher"
        />
      </div>
      <div class="col-xs-12 col-md-6">
        <el-button @click="clearFilter">
          Effacer tous les filtres
        </el-button>
        <!--        <el-button @click="toggleSelection()">-->
        <!--          Effacer la sélection-->
        <!--        </el-button>-->
      </div>
    </div>
    <div class="row">
      <el-table
        ref="teamsTable"
        :data="pagedAndFilteredTeams"
        :default-sort="{prop: 'createdAt', order: 'descending'}"
        border
        stripe
        style="width: 100%"
        @selection-change="handleSelectionChange"
      >
        <!--        <el-table-column-->
        <!--          type="selection"-->
        <!--          width="55"-->
        <!--        />-->
        <el-table-column
          prop="createdAt"
          label="Créé le"
          sortable
        >
          <template slot-scope="scope">
            {{ scope.row.createdAt.date | beautifulDate }}
          </template>
        </el-table-column>
        <el-table-column
          prop="description"
          label="Nom"
          sortable
        />
        <el-table-column
          prop="managers"
          label="Gestionnaire(s)"
        >
          <template slot-scope="scope">
            <p v-if="scope.row.managers.length > 3">
              <el-button
                type="text"
                @click="seeMoreManagers(scope.row.managers)"
              >
                Voir les {{ scope.row.managers.length }} éléments
              </el-button>
            </p>
            <p
              v-for="(manager, managerIndex) in scope.row.managers"
              v-else
              :key="manager.id"
            >
              {{ scope.row.managers[managerIndex].email }}
            </p>
          </template>
        </el-table-column>
        <!--        <el-table-column-->
        <!--          prop="businesses"-->
        <!--          label="Société(s)"-->
        <!--        >-->
        <!--          <template slot-scope="scope">-->
        <!--            <p v-if="scope.row.businesses.length > 3">-->
        <!--              <el-button-->
        <!--                type="text"-->
        <!--                @click="seeMoreBusinesses(scope.row.businesses)"-->
        <!--              >-->
        <!--                Voir les {{ scope.row.businesses.length }} éléments-->
        <!--              </el-button>-->
        <!--            </p>-->
        <!--            <p-->
        <!--              v-for="(business, businessIndex) in scope.row.businesses"-->
        <!--              v-else-->
        <!--              :key="business.id"-->
        <!--            >-->
        <!--              {{ scope.row.businesses[businessIndex].email }}-->
        <!--            </p>-->
        <!--          </template>-->
        <!--        </el-table-column>-->
      </el-table>
    </div>
    <div class="row">
      <el-pagination
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next"
        :total="filteredTeams.length"
        @current-change="handleCurrentChange"
      />
    </div>
  </div>
</template>

<script>
import {mapActions, mapGetters} from "vuex";

export default {
  name: "ManagerTeamTable",
  components: {},
  data() {
    return {
      search: '',
      multipleSelection: [],
      currentPage: 1,
      pageSize: 10,
      team: null
    }
  },
  computed: {
    pagedAndFilteredTeams() {
      return !this.search
        ?
        this.teams.slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)
        :
        this.teams.filter(team => team.description.toLowerCase().includes(this.search.toLowerCase())).slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)

    },
    filteredTeams() {
      return this.search ? this.teams.filter(team => team.description.toLowerCase().includes(this.search.toLowerCase())) : this.teams
    },
    ...mapGetters([
      'isLoading',
      'teams'
    ])
  },
  methods: {
    ...mapActions([
      'loadingStarts',
      'loadingEnds',
    ]),
    handleCurrentChange(val) {
      this.currentPage = val
    },
    toggleSelection(rows) {
      if (rows) {
        rows.forEach(row => {
          this.$refs.teamsTable.toggleRowSelection(row);
        });
      } else {
        this.$refs.teamsTable.clearSelection();
      }
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    filterHandler(value, row, column) {
      const property = column['property'];
      return row[property] === value;
    },
    clearFilter() {
      this.$refs.teamsTable.clearFilter();
    },
    seeMoreManagers(managers) {
      let text = ''
      managers.forEach(manager => {
        text+= manager.email+', '
      });
      text = text.substring(0, text.length-2)
      this.$alert(text, 'Liste des gestionnaires', {
        confirmButtonText: 'Retour'
      });
    },
    // seeMoreBusinesses(businesses) {
    //   let text = ''
    //   businesses.forEach(business => {
    //     text+= business.email+', '
    //   });
    //   text = text.substring(0, text.length-2)
    //   this.$alert(text, 'Liste des sociétés', {
    //     confirmButtonText: 'Retour'
    //   });
    // }
  }
}
</script>

<style scoped>
  .row {
    margin-top: 2vh;
  }
</style>